blob: 6f257c0b34e1fea91b00341922b45986fdde58da [file] [log] [blame]
Phaneendra Manda4c62c802019-03-06 21:37:49 +05301#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret8b823f62019-05-11 11:01:28 -040017# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
Matt Jeanneretf880eb62019-07-16 20:08:03 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040027## Docker related
Matt Jeanneretf880eb62019-07-16 20:08:03 -040028DOCKER_EXTRA_ARGS ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
Matt Jeanneret8b823f62019-05-11 11:01:28 -040031DOCKER_TAG ?= ${VERSION}
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040032ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-openolt-adapter:${DOCKER_TAG}
Andrea Campanellacbf583e2019-12-17 15:26:00 -080033TYPE ?= minimal
Matt Jeanneret8b823f62019-05-11 11:01:28 -040034
35## Docker labels. Only set ref and commit date if committed
Matt Jeanneretf880eb62019-07-16 20:08:03 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret8b823f62019-05-11 11:01:28 -040040
Matt Jeanneretf880eb62019-07-16 20:08:03 -040041DOCKER_BUILD_ARGS ?= \
42 ${DOCKER_EXTRA_ARGS} \
43 --build-arg org_label_schema_version="${VERSION}" \
44 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
45 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
46 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
47 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
48 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
49
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050050# tool containers
Kent Hagermane71b52d2020-02-26 11:13:42 -050051VOLTHA_TOOLS_VERSION ?= 2.0.0
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050052
Kent Hagerman52830082020-02-14 14:53:52 -050053GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050054GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report
55GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura
Kent Hagerman52830082020-02-14 14:53:52 -050056GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint
57HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app $(shell test -t 0 && echo "-it") voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050058
Zack Williams86fdf762020-04-06 18:16:54 -070059.PHONY: docker-build local-protos local-lib-go help
60.DEFAULT_GOAL := help
Phaneendra Manda4c62c802019-03-06 21:37:49 +053061
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040062## Local Development Helpers
Zack Williams86fdf762020-04-06 18:16:54 -070063local-protos: ## Copies a local version of the voltha-protos dependency into the vendor directory
William Kurkianea869482019-04-09 15:16:11 -040064ifdef LOCAL_PROTOS
Esin Karamanccb714b2019-11-29 15:02:06 +000065 rm -rf vendor/github.com/opencord/voltha-protos/v3/go
66 mkdir -p vendor/github.com/opencord/voltha-protos/v3/go
67 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go
68 rm -rf vendor/github.com/opencord/voltha-protos/v3/go/vendor
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040069endif
70
Zack Williams86fdf762020-04-06 18:16:54 -070071local-lib-go: ## Copies a local version of the voltha-lib-go dependency into the vendor directory
Scott Baker355d1742019-10-24 10:57:52 -070072ifdef LOCAL_LIB_GO
Esin Karamanccb714b2019-11-29 15:02:06 +000073 mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg
74 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/
William Kurkianea869482019-04-09 15:16:11 -040075endif
Matt Jeanneret8b823f62019-05-11 11:01:28 -040076
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040077## Docker targets
Zack Williams86fdf762020-04-06 18:16:54 -070078build: docker-build ## Alias for 'docker build'
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040079
Zack Williams86fdf762020-04-06 18:16:54 -070080docker-build: local-protos local-lib-go ## Build openolt adapter docker image
David K. Bainbridge8eb6cd62019-08-22 13:17:29 -070081 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.openolt .
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -040082
Zack Williams86fdf762020-04-06 18:16:54 -070083docker-build-profile: local-protos local-lib-go ## Build openolt adapter docker image with profiling enabled
Matteo Scandolo8f2b9572020-02-28 15:35:23 -080084 docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME}-profile -f docker/Dockerfile.openolt_profile .
85
Zack Williams86fdf762020-04-06 18:16:54 -070086docker-push: ## Push the docker images to an external repository
Matt Jeanneret8b823f62019-05-11 11:01:28 -040087 docker push ${ADAPTER_IMAGENAME}
88
Zack Williams86fdf762020-04-06 18:16:54 -070089docker-kind-load: ## Load docker images into a KinD cluster
Andrea Campanellacbf583e2019-12-17 15:26:00 -080090 @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi
91 kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//')
92
Matt Jeanneret8b823f62019-05-11 11:01:28 -040093## lint and unit tests
Zack Williams86fdf762020-04-06 18:16:54 -070094lint-dockerfile: ## Perform static analysis on Dockerfile
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -050095 @echo "Running Dockerfile lint check ..."
96 @${HADOLINT} $$(find . -name "Dockerfile.*")
97 @echo "Dockerfile lint check OK"
98
Zack Williams86fdf762020-04-06 18:16:54 -070099lint-mod: ## Verify the Go dependencies
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400100 @echo "Running dependency check..."
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500101 @${GO} mod verify
Scott Baker22c0e9c2019-11-26 08:11:29 -0800102 @echo "Dependency check OK. Running vendor check..."
103 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500104 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && git status -- go.mod go.sum vendor && exit 1)
105 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && git status -- go.mod go.sum vendor && exit 1)
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500106 ${GO} mod tidy
107 ${GO} mod vendor
Scott Baker22c0e9c2019-11-26 08:11:29 -0800108 @git status > /dev/null
Kent Hagermane71b52d2020-02-26 11:13:42 -0500109 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
110 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && git status -- go.mod go.sum vendor && git checkout -- go.mod go.sum vendor && exit 1)
Scott Baker22c0e9c2019-11-26 08:11:29 -0800111 @echo "Vendor check OK."
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400112
Zack Williams86fdf762020-04-06 18:16:54 -0700113lint: local-lib-go lint-mod lint-dockerfile ## Run all lint targets
David Bainbridge788e5202019-10-21 18:49:40 +0000114
Zack Williams86fdf762020-04-06 18:16:54 -0700115test: ## Run unit tests
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400116 @mkdir -p ./tests/results
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500117 @${GO} test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400118 RETURN=$$? ;\
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500119 ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
120 ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
Matt Jeanneret384d8c92019-05-06 14:27:31 -0400121 exit $$RETURN
122
Zack Williams86fdf762020-04-06 18:16:54 -0700123sca: ## Runs static code analysis with the golangci-lint tool
Kent Hagermane71b52d2020-02-26 11:13:42 -0500124 @rm -rf ./sca-report
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700125 @mkdir -p ./sca-report
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500126 @echo "Running static code analysis..."
127 @${GOLANGCI_LINT} run --deadline=4m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml
Kent Hagermane71b52d2020-02-26 11:13:42 -0500128 @echo ""
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500129 @echo "Static code analysis OK"
Girish Gowdru6a80bbd2019-07-02 07:36:09 -0700130
Zack Williams86fdf762020-04-06 18:16:54 -0700131clean: distclean ## Removes any local filesystem artifacts generated by a build
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400132
Zack Williams86fdf762020-04-06 18:16:54 -0700133distclean: ## Removes any local filesystem artifacts generated by a build or test run
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500134 rm -rf ./sca-report
Matt Jeanneretb5bf10e2019-05-18 15:02:51 -0400135
Zack Williams86fdf762020-04-06 18:16:54 -0700136mod-update: ## Update go mod files
Kent Hagerman2cd4b7b2020-02-04 15:15:14 -0500137 ${GO} mod tidy
138 ${GO} mod vendor
Zack Williams86fdf762020-04-06 18:16:54 -0700139
140# For each makefile target, add ## <description> on the target line and it will be listed by 'make help'
141help: ## Print help for each Makefile target
142 @echo "Usage: make [<target>]"
143 @echo "where available targets are:"
144 @echo
145 @grep '^[[:alpha:]_-]*:.* ##' $(MAKEFILE_LIST) \
146 | sort | awk 'BEGIN {FS=":.* ## "}; {printf "%-25s : %s\n", $$1, $$2};'